/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the core module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "qtextcodecfactory.h"
#include "qcoreapplication.h"
#include "qtextcodecplugin.h"
#include "private/qfactoryloader_p.h"

#ifndef QT_NO_COMPONENT
Q_GLOBAL_STATIC_WITH_ARGS(QFactoryLoader, loader,
    (QTextCodecFactoryInterface_iid, QCoreApplication::libraryPaths(), QLatin1String("/codecs")))
#endif

QTextCodec *QTextCodecFactory::createForName(const QString &name)
{
#ifndef QT_NO_COMPONENT
    if (QTextCodecFactoryInterface *factory =
        qt_cast<QTextCodecFactoryInterface*>(loader()->instance(name)))
        return factory->create(name);
#endif
    return 0;
}

QTextCodec *QTextCodecFactory::createForMib(int mib)
{
#ifndef QT_NO_COMPONENT
    QString name = QLatin1String("MIB-") + QString::number(mib);
    if (QTextCodecFactoryInterface *factory =
        qt_cast<QTextCodecFactoryInterface*>(loader()->instance(name)))
        return factory->create(name);
#endif
    return 0;
}
